                             
                              (*scanner.mll*)
(*----------------------------------------------------------------------*)



{ open Parser } (* Get the token types *)

rule token = parse
[' ' '\t' '\r' '\n'] { token lexbuf } (* Whitespace *)
| "<*" { comment lexbuf } (* Comments *)
| '(' { LPAREN } (* separators*)
| ')' { RPAREN } 
| '[' { LBRACK } 
| ']' { RBRACK }
| ';' { SEMI } 
| ',' { COMMA }

| '+' { PLUS }   (* operators *)
| '-'  { MINUS }
| '*' { TIMES } 
| '/' { DIVIDE }
| '=' { ASSIGN }
| "==" { EQ }  

| "If" { IF } (* keywords *)
| "Else" { ELSE } 
| "Endif" { ENDIF }
| "Loop" { LOOP }
| "Endloop" { ENDLOOP }
| "Func" { FUNC }
| "Endfunc" { ENDFUNC }
| "Callf" { CALLF }
| "Red" { RED }
| "Blue" { BLUE }
| "White" { WHITE } 
| "Black" { BLACK }
| "Green" { GREEN }
| "Rectangle" {RECTANGLE }
| "Ellipse" { ELLIPSE }
| "Line" { LINE }
| "Text" { TEXT }
| "String" { STRING }
| "Int" { INT }
| "Declare" { DECLARE }
| "Window" { WINDOW }
| "Object" { OBJECT }

| eof { EOF } (* Endoffile*)

| ['0'-'9']+ as lxm { LITERAL(int_of_string lxm) }   (* integers *)

| ['a'-'z' 'A'-'Z']['a'-'z' 'A'-'Z' '0'-'9']* as lxm { ID(lxm) }(*idenfitiers*)

| '"' ['a'-'z' 'A'-'Z' '0'-'9' ' ' ]* '"' as lxm { ST(lxm) } 

| _ as char { raise (Failure("illegal character " ^ Char.escaped char))}


and comment = parse
"*>" { token lexbuf } (* End of comment*)
| _ { comment lexbuf } (* Eat everything else *)


